<?php

if ($argc !== 2) {
  return;
}
$uuid = $argv[1];

$tasks = [
  'inspectionProfiles/Project_Default.xml' => [
    'component/profile' => [
      'inspection_tool' => [
        [
          'attribute' => 'class',
          'value' => 'MessDetectorValidationInspection',
          'content' => '<inspection_tool class="MessDetectorValidationInspection" enabled="true" level="WEAK WARNING" enabled_by_default="true" />',
        ],
        [
          'attribute' => 'class',
          'value' => 'PhpCSValidationInspection',
          'content' => '<inspection_tool class="PhpCSValidationInspection" enabled="true" level="WEAK WARNING" enabled_by_default="true"><option name="CODING_STANDARD" value="Drupal" /><option name="EXTENSIONS" value="php,js,css,inc,module,install" /></inspection_tool>',
        ],
      ],
    ],
  ],
  'php.xml' => [
    'project' => [
      'component' => [
        [
          'attribute' => 'name',
          'value' => 'MessDetector',
          'content' => '<component name="MessDetector"><phpmd_settings><phpmd_by_interpreter interpreter_id="7a28abff-18ef-49a4-889e-453241ccddd0" tool_path="/var/www/html/vendor/bin/phpmd" timeout="30000" /></phpmd_settings></component>',
        ],
        [
          'attribute' => 'name',
          'value' => 'PhpCodeSniffer',
          'content' => '<component name="PhpCodeSniffer"><phpcs_settings><PhpCSConfiguration standards="Drupal;DrupalPractice;MySource;PEAR;PSR1;PSR12;PSR2;SlevomatCodingStandard;Squiz;VariableAnalysis;Zend" /><phpcs_by_interpreter interpreter_id="7a28abff-18ef-49a4-889e-453241ccddd0" beautifier_path="/var/www/html/vendor/bin/phpcbf" tool_path="/var/www/html/vendor/bin/phpcs" timeout="30000" /></phpcs_settings></component>',
        ],
        [
          'attribute' => 'name',
          'value' => 'PHPCodeSnifferOptionsConfiguration',
          'content' => '<component name="PHPCodeSnifferOptionsConfiguration"><option name="codingStandard" value="Drupal" /><option name="installedPaths" value="" /><option name="useInstalledPaths" value="false" /></component>',
        ],
        [
          'attribute' => 'name',
          'value' => 'PhpInterpreters',
          'content' => '<component name="PhpInterpreters"><interpreters><interpreter id="' . $uuid . '" name="php" home="docker-compose://DATA" auto="false" debugger_id="php.debugger.XDebug"><remote_data INTERPRETER_PATH="php" HELPERS_PATH="/opt/.phpstorm_helpers" INITIALIZED="false" VALID="true" RUN_AS_ROOT_VIA_SUDO="false" DOCKER_ACCOUNT_NAME="Docker" DOCKER_COMPOSE_SERVICE_NAME="php" DOCKER_REMOTE_PROJECT_PATH="/opt/project"><type_data command="EXEC" /><dockerComposeConfigurationPaths><item value="$PROJECT_DIR$/docker-compose.yml" /></dockerComposeConfigurationPaths><envs /></remote_data></interpreter></interpreters></component>',
        ],
        [
          'attribute' => 'name',
          'value' => 'PhpUnit',
          'content' => '<component name="PhpUnit"><phpunit_settings><phpunit_by_interpreter interpreter_id="' . $uuid . '" configuration_file_path="/var/www/html/tests/phpunit.xml.dist" custom_loader_path="/var/www/html/vendor/autoload.php" phpunit_phar_path="" use_configuration_file="true" /></phpunit_settings></component>',
        ],
      ],
    ],
  ],
  'workspace.xml' => [
    'project' => [
      'component' => [
        [
          'attribute' => 'name',
          'value' => 'DrupalConfiguration',
          'content' => '<component name="DrupalConfiguration" enabled="true" version="9"><drupalPath>$PROJECT_DIR$/web</drupalPath></component>',
          'keep existing' => TRUE,
        ],
        [
          'attribute' => 'name',
          'value' => 'PhpServers',
          'content' => '<component name="PhpServers"><servers><server host="abc.def.de" id="' . $uuid . '" name="Docker" use_path_mappings="true"><path_mappings><mapping local-root="$PROJECT_DIR$" remote-root="/var/www/html" /></path_mappings></server></servers></component>',
          'keep existing' => TRUE,
        ],
        [
          'attribute' => 'name',
          'value' => 'RunManager',
          'content' => '<component name="RunManager"><configuration name="Docker" type="PhpWebAppRunConfigurationType" factoryName="PHP Web Application" is_https="true" server_name="Docker"><method v="2" /></configuration></component>',
          'keep existing' => TRUE,
        ],
      ],
    ],
  ],
];

foreach ($tasks as $file => $task) {
  $filename = '/drupal/.idea/' . $file;
  if (file_exists($filename)) {
    $delete = [];
    $replace = [];
    $i = 0;
    $xml = simplexml_load_string(file_get_contents($filename));
    foreach ($task as $wrapper => $items) {
      $obj = $xml->xpath('//' . $wrapper);
      if (!$obj) {
        // Ignore for now.
        continue;
      }
      foreach ($items as $xpath => $settings) {
        $elements = $obj[0]->xpath($xpath);
        foreach ($settings as $setting) {
          $exists = FALSE;
          foreach ($elements as $element) {
            foreach ($element->attributes() as $name => $value) {
              if ($name === $setting['attribute'] && (string) $value === $setting['value']) {
                $exists = TRUE;
                if (empty($setting['keep existing'])) {
                  $delete[] = $element;
                }
                break 2;
              }
            }
          }
          if (!$exists || empty($setting['keep existing'])) {
            $i++;
            $obj[0]->addChild('XYZ-' . $i);
            $replace['<XYZ-' . $i . '/>'] = $setting['content'];
          }
        }
      }
    }
    foreach ($delete as $item) {
      $dom = dom_import_simplexml($item);
      $dom->parentNode->removeChild($dom);
    }
    $result = $xml->asXml();
    foreach ($replace as $from => $to) {
      $result = str_replace($from, $to, $result);
    }
    file_put_contents($filename, $result);
  }
}
